<script>
  import { onMount } from "svelte";
  import Layout from "../components/Layout.svelte";
  import {
    Table,
    TableBody,
    TableBodyCell,
    TableBodyRow,
    TableHead,
    TableHeadCell,
    Toggle,
    Button,
    Modal,
    Label,
    Input,
    Toast
  } from "flowbite-svelte";
  import { urlAPI } from "../utils/constants";
  import { FireOutline } from "flowbite-svelte-icons";
  let data = [];
  let defaultModal = false;
  let open = false
  let toastMessageError = ""

  const initialState = {
    name: "",
    number: "",
    email: "",
    active: false,
  };

  let formData = {
    ...initialState,
  };

  const getData = async () => {
    try {
      const response = await fetch(urlAPI + "/correos");
      const result = await response.json();
      data = result[0]; // Asigna los datos de la API a la variable data
    } catch (error) {
      console.error("Error al obtener datos de la API:", error.message);
      toastMessageError = error.message
      open = true
    }
  };

  const enviarFormulario = async () => {
    try {
      const response = await fetch(urlAPI + "/correos", {
        method: "POST",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify(formData),
      });

      const data = await response.json()

      if (data.statusCode == 400) {
        toastMessageError = data.message
        open = true
        return
      }


      formData = initialState;
      defaultModal = false
      getData();
    } catch (error) {
      formData = initialState;
      console.error("Error en la solicitud:", error.message );
      toastMessageError = error.message
      open = true
    }
  };

  const cambiarEstado = async (id, state) => {
    try {
      const response = await fetch(urlAPI + `/correos/${id}`, {
        method: "PATCH",
        headers: {
          "Content-Type": "application/json",
        },
        body: JSON.stringify({
          active: !state
        }),
      });

      const data = await response.json()

      if (data.statusCode == 400) {
        toastMessageError = data.message
        open = true
        return
      }


      getData();
    } catch (error) {
      formData = initialState;
      console.error("Error en la solicitud:", error.message );
      toastMessageError = error.message
      open = true
    }
  }

  onMount(() => {
    getData();
  });
</script>

<Layout>
  <Toast bind:open position="bottom-right">
    <FireOutline slot="icon" class="w-5 h-5 text-primary-500 bg-primary-100 dark:bg-primary-800 dark:text-primary-200" />
    { toastMessageError }
  </Toast>
  <Modal title="Crear usuario" bind:open={defaultModal} autoclose>
    <form on:submit|preventDefault={enviarFormulario}>
      <div class="mb-6">
        <Label for="name" class="block mb-2">Nombre</Label>
        <Input
          id="name"
          size="lg"
          placeholder="Nombre..."
          bind:value={formData.name}
        />
      </div>

      <div class="mb-6">
        <Label for="number" class="block mb-2">Número</Label>
        <Input
          id="number"
          size="lg"
          placeholder="999999999..."
          bind:value={formData.number}
        />
      </div>

      <div class="mb-6">
        <Label for="email" class="block mb-2">Email</Label>
        <Input
          id="email"
          size="lg"
          type="email"
          placeholder="example@example.com"
          bind:value={formData.email}
        />
      </div>

      <div class="mb-6">
        <Label for="active" class="block mb-2">Estado</Label>
        <Toggle id="active" bind:checked={formData.active}>Activado</Toggle>
      </div>
    </form>
    <svelte:fragment slot="footer">
      <Button on:click={() => enviarFormulario()}>Crear</Button>
      <Button color="alternative">Cancelar</Button>
    </svelte:fragment>
  </Modal>
  <div>
    <div class="flex items-center justify-between mb-4">
      <h1 class="mb-4">Emails</h1>
      <Button on:click={() => (defaultModal = true)}>Agregar</Button>
    </div>
    <Table>
      <TableHead>
        <TableHeadCell>ID</TableHeadCell>
        <TableHeadCell>Nombre</TableHeadCell>
        <TableHeadCell>Email</TableHeadCell>
        <TableHeadCell>Acciones</TableHeadCell>
      </TableHead>
      <TableBody tableBodyClass="divide-y">
        {#each data as item (item.id)}
          <TableBodyRow key={item.id}>
            <TableBodyCell>{item.id}</TableBodyCell>
            <TableBodyCell>{item.name}</TableBodyCell>
            <TableBodyCell>{item.email}</TableBodyCell>
            <TableBodyCell>
              <Toggle checked={item.active} on:change={(e) => (cambiarEstado(item.id, item.active))}>Activo</Toggle>
            </TableBodyCell>
          </TableBodyRow>
        {/each}
      </TableBody>
    </Table>
  </div>
</Layout>
